public class Car {
    public double x,y;
    public double speed;
    public double acceleration;
    public double direction;
    public double friction;
    public int w,h;

    public Car (double x,double y,int w,int h){
        this.x = x;
        this.y = y;
        speed = 0;
        acceleration = 0;
        direction = 0;
        friction = 0.1;
        this.w = w;
        this.h = h;
    }

    public void move(){
        speed += acceleration;
        speed -= friction * speed;
        x += Math.cos(direction)*speed;
        y += Math.sin(direction)*speed;
        if(x > w)
            x = 0;
        if(x < 0)
            x = w;
        if(y > h)
            y = 0;
        if(y < 0)
            y = h;
    }

    public void draw(Graphics g){
        double[] xs = {-1,2,2,-1};
        double[] ys = {1,1,-1,-1};

        for(int i=0;i<xs.length;i++){
            xs[i]*=10;
            ys[i]*=10;
        }

        // rotate and translate. 
        int[] tx = new int[xs.length];
        int[] ty = new int[ys.length];
        // cos, -sin
        // sin, cos
        double sin = Math.sin(direction);
        double cos = Math.cos(direction);
        for(int i=0;i<xs.length;i++){
            tx[i] = (int)
                (x + (cos * xs[i] + -sin * ys[i]));
            ty[i] = (int)
                (y + (sin * xs[i] + cos * ys[i]));
            ty[i] = ty[i] * -1 + h;
        }
        g.setColor(Color.red);
        g.fillPolygon(tx,ty,tx.length);
        g.setColor(Color.black);
        g.drawPolygon(tx,ty,tx.length);
    }
}

