
import java.io.*;
import java.net.*;
import java.util.*;

public class ChatServer implements Runnable {
    static Vector clients = new Vector();

    Socket sock;
    BufferedReader br;
    PrintStream ps;

    public ChatServer(Socket s) throws IOException {
        sock = s;
        br = new BufferedReader(new InputStreamReader(s.getInputStream()));
        ps = new PrintStream(s.getOutputStream());
        clients.addElement(this);
    }
    
    public void run(){
        try{
            for(;;){
                String line = br.readLine();
                for(int i=0;i<clients.size();i++){
                    ChatServer ch = (ChatServer)(clients.elementAt(i));
                    ch.ps.println(line);
                }
            }
        }catch(IOException e){
            clients.removeElement(this);
        }
    }

    public static void main(String[] args) throws Throwable {
        for(int i=0;i<args.length;i++){
            String[] nv = args[i].split("=",2);
            System.setProperty(nv[0],nv.length > 1 ? nv[1] : "on");            
        }
        ServerSocket sock = new ServerSocket(Integer.parseInt(System.getProperty("port","12345")));
        for(;;){
            Socket cli = sock.accept();
            Thread t = new Thread(new ChatServer(cli));
            t.start();
        }
    }
}

