
import java.io.*;
import java.net.*;
import java.util.*;

public class GameServer implements Runnable {
    static Vector clients = new Vector();

    Car car;
    boolean[] keys;
    Socket sock;
    BufferedReader br;
    PrintStream ps;

    public GameServer(Socket s) throws IOException {
        sock = s;
        br = new BufferedReader(new InputStreamReader(s.getInputStream()));
        ps = new PrintStream(s.getOutputStream());
        clients.addElement(this);
        car = new Car(Math.random()*100,Math.random()*100,640,480);
        keys = new boolean[0x1001];
    }
    
    public void run(){
        try{
            for(;;){
                String line = br.readLine();
                String[] action = line.split(",");
                int key = Integer.parseInt(action[1]);
                if(action[0].equals("p")){
                    if(key < 0x1000)
                        keys[key] = true;
                }else if(action[0].equals("r")){
                    if(key < 0x1000)
                        keys[key] = false;                
                }
            }
        }catch(Exception e){
            clients.removeElement(this);
        }
    }

    public static void main(String[] args) throws Throwable {
        for(int i=0;i<args.length;i++){
            String[] nv = args[i].split("=",2);
            System.setProperty(nv[0],nv.length > 1 ? nv[1] : "on");            
        }
        ServerSocket sock = new ServerSocket(Integer.parseInt(System.getProperty("port","12345")));
        for(;;){
            Socket cli = sock.accept();
            Thread t = new Thread(new GameServer(cli));
            t.start();
        }
    }
}

