import java.io.*;
import java.net.*;

public class MyThreadedServer implements Runnable {

    Socket sock;
    BufferedReader br;
    PrintStream ps;

    public MyThreadedServer(Socket s) throws IOException {
        sock = s;
        br = new BufferedReader(new InputStreamReader(s.getInputStream()));
        ps = new PrintStream(s.getOutputStream());
    }

    public void run(){
        try {
            String line = br.readLine();
            while(line != null){
                System.out.println(line); 
                if(line.length() == 0)
                    break;
                line = br.readLine();
            }
            // closed connection or we got a blank line.
            ps.println("HTTP/1.0 200 OK");
            ps.println("Content-Type: text/html");
            ps.println("");
            ps.println("<html><body><h1>Hello World: "+System.currentTimeMillis()+"</h1></body></html>");
            ps.close();
        }catch(IOException e){
            System.out.println("err: "+e);
        }
    }

    public static void main(String[] args) throws Throwable {
        if(args.length < 1){
            System.out.println("usage: [port]");
            return;
        }
        int port = Integer.parseInt(args[0]);

        ServerSocket sock = new ServerSocket(port);
        for(;;){
            // accept a connection
            Socket clisock = sock.accept();
            // create new instance of server.
            MyThreadedServer serv = new MyThreadedServer(clisock);
            // create a new Thread (to run server).
            Thread t = new Thread(serv);
            t.start();  // start thread.
        }
    }
}


